Package org.apache.lucene.search

# Class KnnCollector.Decorator

java.lang.Object
org.apache.lucene.search.KnnCollector.Decorator

All Implemented Interfaces:
  `KnnCollector`

Direct Known Subclasses:
  `HnswQueueSaturationCollector`, `MultiLeafKnnCollector`, `OrdinalTranslatedKnnCollector`

Enclosing interface:
  `KnnCollector`

public abstract static class KnnCollector.Decorator extends Object implements KnnCollector
KnnCollector.Decorator is the base class for decorators of KnnCollector objects, which extend the object with new behaviors.

WARNING: This API is experimental and might change in incompatible ways in the next release.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface org.apache.lucene.search.KnnCollector

  `KnnCollector.Decorator`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected final KnnCollector`
  `collector`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Decorator(KnnCollector collector)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `collect(int docId, float similarity)`
  Collect the provided docId and include in the result set.
  `boolean`
  `earlyTerminated()`
  If search visits too many documents, the results collector will terminate early.
  `KnnSearchStrategy`
  `getSearchStrategy()`
  `void`
  `incVisitedCount(int count)`
  `int`
  `k()`
  `float`
  `minCompetitiveSimilarity()`
  This method is utilized during search to ensure only competitive results are explored.
  `TopDocs`
  `topDocs()`
  This drains the collected nearest kNN results and returns them in a new `TopDocs` collection, ordered by score descending.
  `long`
  `visitedCount()`
  `long`
  `visitLimit()`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### collector

    protected final KnnCollector collector

- ## Constructor Details

  - ### Decorator

    public Decorator(KnnCollector collector)

- ## Method Details

  - ### earlyTerminated

    public boolean earlyTerminated()
    Description copied from interface: `KnnCollector`
    If search visits too many documents, the results collector will terminate early. Usually, this is due to some restricted filter on the document set.

    When collection is earlyTerminated, the results are not a correct representation of k nearest neighbors.

    Specified by:
      `earlyTerminated` in interface `KnnCollector`
    Returns:
      is the current result set marked as incomplete?

  - ### incVisitedCount

    public void incVisitedCount(int count)
    Specified by:
      `incVisitedCount` in interface `KnnCollector`
    Parameters:
      `count` - increments the visited vector count, must be greater than 0.

  - ### visitedCount

    public long visitedCount()
    Specified by:
      `visitedCount` in interface `KnnCollector`
    Returns:
      the current visited vector count

  - ### visitLimit

    public long visitLimit()
    Specified by:
      `visitLimit` in interface `KnnCollector`
    Returns:
      the visited vector limit

  - ### k

    public int k()
    Specified by:
      `k` in interface `KnnCollector`
    Returns:
      the expected number of collected results

  - ### collect

    public boolean collect(int docId, float similarity)
    Description copied from interface: `KnnCollector`
    Collect the provided docId and include in the result set.
    Specified by:
      `collect` in interface `KnnCollector`
    Parameters:
      `docId` - of the vector to collect
      `similarity` - its calculated similarity
    Returns:
      true if the vector is collected

  - ### minCompetitiveSimilarity

    public float minCompetitiveSimilarity()
    Description copied from interface: `KnnCollector`
    This method is utilized during search to ensure only competitive results are explored.

    Consequently, if this results collector wants to collect `k` results, this should return `Float.NEGATIVE_INFINITY` when not full.

    When full, the minimum score should be returned.

    Specified by:
      `minCompetitiveSimilarity` in interface `KnnCollector`
    Returns:
      the current minimum competitive similarity in the collection

  - ### topDocs

    public TopDocs topDocs()
    Description copied from interface: `KnnCollector`
    This drains the collected nearest kNN results and returns them in a new `TopDocs` collection, ordered by score descending. NOTE: This is generally a destructive action and the collector should not be used after topDocs() is called.
    Specified by:
      `topDocs` in interface `KnnCollector`
    Returns:
      The collected top documents

  - ### getSearchStrategy

    public KnnSearchStrategy getSearchStrategy()
    Specified by:
      `getSearchStrategy` in interface `KnnCollector`
    Returns:
      the search strategy used by this collector, can be null